Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 2319)
+++ /palm/trunk/SOURCE/Makefile	(revision 2320)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# -ls_forcing nudging
+# +large_scale_forcing_nudging
+# 
+# 2318 2017-07-20 17:27:44Z suehring
 # Add further dependencies on surface_mod
 # 
@@ -370,6 +374,6 @@
 	lpm_set_attributes.f90 lpm_splitting.f90 \
 	lpm_write_exchange_statistics.f90 lpm_write_restart_file.f90 \
-	ls_forcing_mod.f90 message.f90 microphysics_mod.f90 modules.f90 mod_kinds.f90 \
-	mod_particle_attributes.f90 netcdf_interface_mod.f90 nudging_mod.f90 \
+        large_scale_forcing_nudging_mod.f90 message.f90 microphysics_mod.f90 \
+        modules.f90 mod_kinds.f90 mod_particle_attributes.f90 netcdf_interface_mod.f90 \
 	outflow_turbulence.f90 package_parin.f90 palm.f90 parin.f90 plant_canopy_model_mod.f90 \
 	pmc_interface_mod.f90 pmc_child_mod.f90 pmc_general_mod.f90 pmc_handle_communicator_mod.f90 \
@@ -453,5 +457,5 @@
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o \
 	netcdf_interface_mod.o posix_calls_from_fortran.o
-check_parameters.o: modules.o mod_kinds.o land_surface_model_mod.o \
+check_parameters.o: modules.o mod_kinds.o land_surface_model_mod.o large_scale_forcing_nudging_mod.o \
 	microphysics_mod.o netcdf_interface_mod.o plant_canopy_model_mod.o pmc_interface_mod.o \
 	radiation_model_mod.o spectra_mod.o subsidence_mod.o synthetic_turbulence_generator_mod.o \
@@ -493,14 +497,14 @@
 fft_xy_mod.o: modules.o mod_kinds.o singleton_mod.o temperton_fft_mod.o
 flow_statistics.o: modules.o cpulog_mod.o mod_kinds.o land_surface_model_mod.o \
-   netcdf_interface_mod.o radiation_model_mod.o surface_mod.o
+                   large_scale_forcing_nudging_mod.o netcdf_interface_mod.o radiation_model_mod.o surface_mod.o
 global_min_max.o: modules.o mod_kinds.o
-header.o: modules.o cpulog_mod.o mod_kinds.o netcdf_interface_mod.o land_surface_model_mod.o\
-   microphysics_mod.o plant_canopy_model_mod.o pmc_handle_communicator_mod.o pmc_interface_mod.o \
-   radiation_model_mod.o spectra_mod.o subsidence_mod.o surface_mod.o virtual_flight_mod.o
+header.o: modules.o cpulog_mod.o mod_kinds.o large_scale_forcing_nudging_mod.o netcdf_interface_mod.o \
+   land_surface_model_mod.o microphysics_mod.o plant_canopy_model_mod.o pmc_handle_communicator_mod.o \
+   pmc_interface_mod.o radiation_model_mod.o spectra_mod.o subsidence_mod.o surface_mod.o virtual_flight_mod.o
 inflow_turbulence.o: modules.o cpulog_mod.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
 init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog_mod.o disturb_heatflux.o land_surface_model_mod.o \
-   lpm_init.o ls_forcing_mod.o netcdf_interface_mod.o plant_canopy_model_mod.o \
-   radiation_model_mod.o random_function_mod.o random_generator_parallel_mod.o \
+   large_scale_forcing_nudging_mod.o lpm_init.o netcdf_interface_mod.o \
+   plant_canopy_model_mod.o radiation_model_mod.o random_function_mod.o random_generator_parallel_mod.o \
    microphysics_mod.o mod_particle_attributes.o surface_layer_fluxes_mod.o \
    urban_surface_mod.o virtual_flight_mod.o surface_mod.o wind_turbine_model_mod.o 
@@ -518,4 +522,5 @@
 interaction_droplets_ptq.o: modules.o mod_kinds.o
 land_surface_model_mod.o: modules.o mod_kinds.o radiation_model_mod.o surface_mod.o
+large_scale_forcing_nudging_mod.o: modules.o cpulog_mod.o mod_kinds.o surface_mod.o
 local_stop.o: modules.o mod_kinds.o pmc_interface_mod.o
 local_tremain.o: modules.o cpulog_mod.o mod_kinds.o
@@ -551,5 +556,4 @@
 lpm_write_exchange_statistics.o: modules.o mod_kinds.o mod_particle_attributes.o
 lpm_write_restart_file.o: modules.o mod_kinds.o mod_particle_attributes.o
-ls_forcing_mod.o: modules.o cpulog_mod.o mod_kinds.o surface_mod.o
 message.o: modules.o mod_kinds.o pmc_interface_mod.o
 microphysics_mod.o: modules.o cpulog_mod.o mod_kinds.o surface_mod.o
@@ -559,8 +563,7 @@
 netcdf_interface_mod.o: netcdf_interface_mod.f90 modules.o mod_kinds.o \
    land_surface_model_mod.o radiation_model_mod.o spectra_mod.o urban_surface_mod.o
-nudging_mod.o: modules.o cpulog_mod.o mod_kinds.o
 outflow_turbulence.o: modules.o cpulog_mod.o mod_kinds.o
 package_parin.o: modules.o mod_kinds.o mod_particle_attributes.o
-palm.o: modules.o cpulog_mod.o land_surface_model_mod.o ls_forcing_mod.o mod_kinds.o nudging_mod.o\
+palm.o: modules.o cpulog_mod.o land_surface_model_mod.o mod_kinds.o \
 	pmc_interface_mod.o surface_layer_fluxes_mod.o
 parin.o: modules.o cpulog_mod.o land_surface_model_mod.o mod_kinds.o netcdf_interface_mod.o \
@@ -589,6 +592,7 @@
 	advec_ws.o buoyancy.o calc_radiation.o coriolis.o \
 	cpulog_mod.o diffusion_e.o diffusion_s.o diffusion_u.o diffusion_v.o diffusion_w.o \
-	eqn_state_seawater.o mod_kinds.o microphysics_mod.o \
-	nudging_mod.o plant_canopy_model_mod.o production_e.o radiation_model_mod.o \
+	eqn_state_seawater.o large_scale_forcing_nudging_mod.o modules.o cpulog_mod.o mod_kinds.o surface_mod.o \
+        mod_kinds.o microphysics_mod.o \
+	plant_canopy_model_mod.o production_e.o radiation_model_mod.o \
 	subsidence_mod.o surface_mod.o user_actions.o wind_turbine_model_mod.o
 progress_bar_mod.o: modules.o mod_kinds.o
@@ -620,5 +624,5 @@
 time_integration.o: modules.o advec_ws.o buoyancy.o calc_mean_profile.o \
 	cpulog_mod.o data_output_flight.o disturb_heatflux.o interaction_droplets_ptq.o land_surface_model_mod.o \
-	ls_forcing_mod.o mod_kinds.o nudging_mod.o pmc_interface_mod.o production_e.o \
+	large_scale_forcing_nudging_mod.o mod_kinds.o pmc_interface_mod.o production_e.o \
 	prognostic_equations.o progress_bar_mod.o radiation_model_mod.o \
 	spectra_mod.o user_actions.o microphysics_mod.o synthetic_turbulence_generator_mod.o \
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 2319)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Remove unused control parameter large_scale_forcing from only-list
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -166,5 +169,5 @@
                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_s_b, ibc_s_t,         &
                ibc_sa_t, ibc_uv_b, ibc_uv_t, inflow_l, inflow_n, inflow_r,     &
-               inflow_s, intermediate_timestep_count, large_scale_forcing,     &
+               inflow_s, intermediate_timestep_count,                          &
                microphysics_morrison, microphysics_seifert, nest_domain,       &
                nest_bound_l, nest_bound_s, nudging, ocean, outflow_l,          &
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2319)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2320)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-!
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+!
+! 2312 2017-07-14 20:26:51Z hoffmann
 ! PA0349 and PA0420 removed.
 !
@@ -498,4 +501,8 @@
         ONLY: lsm_check_data_output, lsm_check_data_output_pr,                 &
               lsm_check_parameters
+
+    USE lsf_nudging_mod,                                                       &
+        ONLY:  lsf_nudging_check_parameters, lsf_nudging_check_data_output_pr, &
+               qsws_surf, shf_surf
 
     USE kinds
@@ -1227,4 +1234,8 @@
 !-- When radiation model is used, peform addtional checks
     IF ( radiation )  CALL radiation_check_parameters
+!
+!-- When large-scale forcing or nudging is used, peform addtional checks
+    IF ( large_scale_forcing  .OR.  nudging )  CALL lsf_nudging_check_parameters
+
 
 
@@ -2848,100 +2859,4 @@
              ENDIF
 
-          CASE ( 'td_lsa_lpt' )
-             IF (  .NOT.  large_scale_forcing )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for large_scale_forcing = .FALSE.'
-                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 81
-                dopr_unit(i)  = 'K/s'
-                hom(:,2,81,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_lsa_q' )
-             IF (  .NOT.  large_scale_forcing )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for large_scale_forcing = .FALSE.'
-                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 82
-                dopr_unit(i)  = 'kg/kgs'
-                hom(:,2,82,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_sub_lpt' )
-             IF (  .NOT.  large_scale_forcing )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for large_scale_forcing = .FALSE.'
-                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 83
-                dopr_unit(i)  = 'K/s'
-                hom(:,2,83,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_sub_q' )
-             IF (  .NOT.  large_scale_forcing )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for large_scale_forcing = .FALSE.'
-                CALL message( 'check_parameters', 'PA0393', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 84
-                dopr_unit(i)  = 'kg/kgs'
-                hom(:,2,84,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_nud_lpt' )
-             IF (  .NOT.  nudging )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for nudging = .FALSE.'
-                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 85
-                dopr_unit(i)  = 'K/s'
-                hom(:,2,85,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_nud_q' )
-             IF (  .NOT.  nudging )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for nudging = .FALSE.'
-                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 86
-                dopr_unit(i)  = 'kg/kgs'
-                hom(:,2,86,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_nud_u' )
-             IF (  .NOT.  nudging )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for nudging = .FALSE.'
-                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 87
-                dopr_unit(i)  = 'm/s2'
-                hom(:,2,87,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'td_nud_v' )
-             IF (  .NOT.  nudging )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not imp' // &
-                                 'lemented for nudging = .FALSE.'
-                CALL message( 'check_parameters', 'PA0394', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 88
-                dopr_unit(i)  = 'm/s2'
-                hom(:,2,88,:) = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
           CASE ( 's*2' )
              IF (  .NOT.  passive_scalar )  THEN
@@ -2962,4 +2877,7 @@
              CALL lsm_check_data_output_pr( data_output_pr(i), i, unit,        &
                                             dopr_unit(i) )
+
+             CALL lsf_nudging_check_data_output_pr( data_output_pr(i), i,      &
+                                                    unit, dopr_unit(i) )
 
              IF ( unit == 'illegal' )  THEN
@@ -3885,45 +3803,4 @@
 
 !
-!-- Check nudging and large scale forcing from external file
-    IF ( nudging  .AND.  (  .NOT.  large_scale_forcing ) )  THEN
-       message_string = 'Nudging requires large_scale_forcing = .T.. &'//      &
-                        'Surface fluxes and geostrophic wind should be &'//    &
-                        'prescribed in file LSF_DATA'
-       CALL message( 'check_parameters', 'PA0374', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( large_scale_forcing  .AND.  ( bc_lr /= 'cyclic'  .OR.                 &
-                                    bc_ns /= 'cyclic' ) )  THEN
-       message_string = 'Non-cyclic lateral boundaries do not allow for &' //  &
-                        'the usage of large scale forcing from external file.'
-       CALL message( 'check_parameters', 'PA0375', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( large_scale_forcing  .AND.  (  .NOT.  humidity ) )  THEN
-       message_string = 'The usage of large scale forcing from external &'//   &
-                        'file LSF_DATA requires humidity = .T..'
-       CALL message( 'check_parameters', 'PA0376', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( large_scale_forcing  .AND.  passive_scalar )  THEN
-       message_string = 'The usage of large scale forcing from external &'//   &
-                        'file LSF_DATA is not implemented for passive scalars'
-       CALL message( 'check_parameters', 'PA0440', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( large_scale_forcing  .AND.  topography /= 'flat'                      &
-                              .AND.  .NOT.  lsf_exception )  THEN
-       message_string = 'The usage of large scale forcing from external &'//   &
-                        'file LSF_DATA is not implemented for non-flat topography'
-       CALL message( 'check_parameters', 'PA0377', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( large_scale_forcing  .AND.  ocean )  THEN
-       message_string = 'The usage of large scale forcing from external &'//   &
-                        'file LSF_DATA is not implemented for ocean runs'
-       CALL message( 'check_parameters', 'PA0378', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
 !-- Prevent empty time records in volume, cross-section and masked data in case
 !-- of non-parallel netcdf-output in restart runs
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 2319)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+! 
+! 2296 2017-06-28 07:53:56Z maronga
 ! Enabled output of radiation quantities for radiation_scheme = 'constant'
 ! 
@@ -243,6 +246,5 @@
                momentumflux_output_conversion, nc, nr, p, prho, prr, pt, q,    &
                qc, ql, qr, rho_air, rho_air_zw, rho_ocean, s,                  &
-               sa, td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, time_vert, u,   &
-               ug, v, vg, vpt, w, w_subs, waterflux_output_conversion, zw
+               sa, u, ug, v, vg, vpt, w, w_subs, waterflux_output_conversion, zw
         
     USE cloud_parameters,                                                      &
@@ -272,4 +274,7 @@
     USE land_surface_model_mod,                                                &
         ONLY:   m_soil_h, nzb_soil, nzt_soil, t_soil_h
+
+    USE lsf_nudging_mod,                                                       &
+        ONLY:   td_lsa_lpt, td_lsa_q, td_sub_lpt, td_sub_q, time_vert
 
     USE netcdf_interface,                                                      &
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 2319)
+++ /palm/trunk/SOURCE/header.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+! 
+! 2300 2017-06-29 13:31:14Z raasch
 ! host-specific code removed
 ! 
@@ -342,4 +345,7 @@
     USE land_surface_model_mod,                                                &
         ONLY: lsm_header
+
+    USE lsf_nudging_mod,                                                       &
+        ONLY:  lsf_nudging_header
 
     USE microphysics_mod,                                                      &
@@ -746,41 +752,5 @@
 !
 !-- Large scale forcing and nudging
-    WRITE ( io, 160 )
-    IF ( large_scale_forcing )  THEN
-       WRITE ( io, 162 )
-       WRITE ( io, 163 )
-
-       IF ( large_scale_subsidence )  THEN
-          IF ( .NOT. use_subsidence_tendencies )  THEN
-             WRITE ( io, 164 )
-          ELSE
-             WRITE ( io, 165 )
-          ENDIF 
-       ENDIF
-
-       IF ( bc_pt_b == 'dirichlet' )  THEN
-          WRITE ( io, 180 )
-       ELSEIF ( bc_pt_b == 'neumann' )  THEN
-          WRITE ( io, 181 )
-       ENDIF
-
-       IF ( bc_q_b == 'dirichlet' )  THEN
-          WRITE ( io, 182 )
-       ELSEIF ( bc_q_b == 'neumann' )  THEN
-          WRITE ( io, 183 )
-       ENDIF
-
-       WRITE ( io, 167 )
-       IF ( nudging )  THEN
-          WRITE ( io, 170 )
-       ENDIF
-    ELSE
-       WRITE ( io, 161 )
-       WRITE ( io, 171 )
-    ENDIF
-    IF ( large_scale_subsidence )  THEN
-       WRITE ( io, 168 )
-       WRITE ( io, 169 )
-    ENDIF
+    IF ( large_scale_forcing )  CALL lsf_nudging_header( io )
 
 !
@@ -2012,21 +1982,4 @@
            /'     ',2(1X,E12.5),'Pa/m in x/y direction', &
            /'     starting from dp_level_b =', F8.3, 'm', A /)
-160 FORMAT (//' Large scale forcing and nudging:'/ &
-              ' -------------------------------'/)
-161 FORMAT (' --> No large scale forcing from external is used (default) ')
-162 FORMAT (' --> Large scale forcing from external file LSF_DATA is used: ')
-163 FORMAT ('     - large scale advection tendencies ')
-164 FORMAT ('     - large scale subsidence velocity w_subs ')
-165 FORMAT ('     - large scale subsidence tendencies ')
-167 FORMAT ('     - and geostrophic wind components ug and vg')
-168 FORMAT (' --> Large-scale vertical motion is used in the ', &
-                  'prognostic equation(s) for')
-169 FORMAT ('     the scalar(s) only')
-170 FORMAT (' --> Nudging is used')
-171 FORMAT (' --> No nudging is used (default) ')
-180 FORMAT ('     - prescribed surface values for temperature')
-181 FORMAT ('     - prescribed surface fluxes for temperature')
-182 FORMAT ('     - prescribed surface values for humidity')
-183 FORMAT ('     - prescribed surface fluxes for humidity')
 200 FORMAT (//' Run time and time step information:'/ &
              ' ----------------------------------'/)
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 2319)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 2320)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularize large-scale forcing and nudging
+! 
+! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
 ! includes two more prognostic equations for cloud drop concentration (nc)  
@@ -372,5 +375,6 @@
         ONLY:  lsm_init, lsm_init_arrays
   
-    USE ls_forcing_mod
+    USE lsf_nudging_mod,                                                       &
+        ONLY:  lsf_init, ls_forcing_surf, nudge_init 
 
     USE microphysics_mod,                                                      &
@@ -956,4 +960,16 @@
 
 !
+!-- Initialize nudging if required
+    IF ( nudging )  THEN
+       CALL nudge_init
+    ENDIF
+
+!
+!-- Initialize reading of large scale forcing from external file - if required
+    IF ( large_scale_forcing )  THEN
+       CALL lsf_init
+    ENDIF
+
+!
 !-- Allocate arrays containing the RK coefficient for calculation of 
 !-- perturbation pressure and turbulent fluxes. At this point values are
@@ -1092,19 +1108,4 @@
 
           CALL location_message( 'initializing with constant profiles', .FALSE. )
-!
-!--       Overwrite initial profiles in case of nudging
-          IF ( nudging )  THEN
-             pt_init = ptnudge(:,1)
-             u_init  = unudge(:,1)
-             v_init  = vnudge(:,1)
-             IF ( humidity  )  THEN ! is passive_scalar correct???
-                q_init = qnudge(:,1)
-             ENDIF
-
-             WRITE( message_string, * ) 'Initial profiles of u, v and ',       &
-                 'scalars from NUDGING_DATA are used.'
-             CALL message( 'init_3d_model', 'PA0370', 0, 0, 0, 6, 0 )
-          ENDIF
-
 !
 !--       Overwrite initial profiles in case of synthetic turbulence generator
